#include <bits/stdc++.h>
using namespace std;
int main(){
long long c,n,q,a,b,s;
cin>>n>>c>>q;
cin>>s;
long long niz[n];
for(int i=0; i<n; i++){
    niz[i]=(s/pow(10,n-i-1));
    niz[i]=niz[i]%10;
}
if(c==n){
for(int i=0; i<q; i++){
    cin>>a>>b;
    for(int j=a-1; j<b; j++)
        niz[j]=abs(1-niz[j]);
    long long br1=0;
    for(int j=0; i<n; i++){
        if(niz[j]==1) br1++;
    }
    cout<<br1<<endl;
}
}
else if(c==1){
    for(int i=0; i<q; i++){
        cin>>a>>b;
        for(int j=a-1; j<b; j++)
            niz[j]=abs(1-niz[j]);
        long long brgrupa1=0,brgrupa0=0;
        for(int j=0; j<n-1; j++){
            if(niz[j]!=niz[j+1] && niz[j]==1) brgrupa1++;
            if(niz[j]!=niz[j+1] && niz[j]==0) brgrupa0++;
        }
        if(niz[n-1]==1) brgrupa1++;
        else brgrupa0++;
        if(brgrupa1>=brgrupa0+2) cout<<brgrupa0+1;
        else cout<<brgrupa1;
    }
}
return 0;
}